import { CompositeLayer, DefaultProps } from '@deck.gl/core';
import { PathOutlineLayerProps } from "../path-outline-layer/path-outline-layer.js";
import { Arrow2DGeometry } from "./arrow-2d-geometry.js";
import { Vector3 } from '@math.gl/core';
export type PathMarkerLayerProps<DataT> = PathOutlineLayerProps<DataT> & {
    getDirection?: (x: any) => any;
    getMarkerColor?: (x: any) => number[];
    getMarkerPercentages?: (x: any, info: any) => number[];
    highlightPoint?: any;
    highlightIndex?: number;
    MarkerLayer?: any;
    markerLayerProps?: any;
    sizeScale?: number;
    fp64?: boolean;
    nebulaLayer?: any;
};
export declare class PathMarkerLayer<DataT = any, ExtraPropsT = Record<string, unknown>> extends CompositeLayer<ExtraPropsT & Required<PathMarkerLayerProps<DataT>>> {
    static layerName: string;
    static defaultProps: DefaultProps<PathMarkerLayerProps<any>>;
    state: {
        closestPoint: Vector3 | null;
        closestPoints?: {
            position: Vector3;
        }[];
        markers: any[];
        mesh: Arrow2DGeometry;
    };
    initializeState(): void;
    projectFlat(xyz: any, viewport: any, coordinateSystem: any, coordinateOrigin: any): any;
    updateState({ props, oldProps, changeFlags }: {
        props: any;
        oldProps: any;
        changeFlags: any;
    }): void;
    _recalculateClosestPoint(): void;
    getPickingInfo({ info }: {
        info: any;
    }): any;
    renderLayers(): any[];
}
//# sourceMappingURL=path-marker-layer.d.ts.map