import { PathLayer, PathLayerProps } from '@deck.gl/layers';
import type { DefaultProps, LayerContext } from '@deck.gl/core';
import { Framebuffer, Texture } from '@luma.gl/core';
/**
 * Unit literal to shader unit number conversion.
 */
export declare const UNIT: {
    common: number;
    meters: number;
    pixels: number;
};
export type PathOutlineLayerProps<DataT> = PathLayerProps<DataT> & {
    dashJustified?: boolean;
    getDashArray?: [number, number] | ((d: DataT) => [number, number] | null);
    getZLevel?: (d: DataT, index: number) => number;
};
export declare class PathOutlineLayer<DataT = any, ExtraPropsT = Record<string, unknown>> extends PathLayer<DataT, ExtraPropsT & Required<PathOutlineLayerProps<DataT>>> {
    static layerName: string;
    static defaultProps: DefaultProps<PathOutlineLayerProps<any>>;
    state: {
        model?: any;
        pathTesselator: any;
        outlineFramebuffer: Framebuffer;
        dummyTexture: Texture;
    };
    getShaders(): any;
    initializeState(context: LayerContext): void;
    draw({ moduleParameters, parameters, uniforms, context }: {
        moduleParameters?: {};
        parameters: any;
        uniforms: any;
        context: any;
    }): void;
}
//# sourceMappingURL=path-outline-layer.d.ts.map