import { CompositeLayer } from '@deck.gl/core';
import { TileLayer, TileLayerProps } from '@deck.gl/geo-layers';
import type { TileSource } from '@loaders.gl/loader-utils';
export type TileSourceLayerProps = TileLayerProps & {
    tileSource: TileSource<any>;
    showTileBorders?: boolean;
};
/**
 * A Deck.gl layer that renders a tile source
 * Autodiscovers type of content (vector tile, bitmap, ...)
 * Can render debug borders around tiles
 * TODO - Change debug border color based on zoom level
 */
export declare class TileSourceLayer extends CompositeLayer<TileSourceLayerProps> {
    static layerName: string;
    static defaultProps: {
        showTileBorders: boolean;
    };
    state: {
        tileSource: TileSource<any> | null;
    };
    initializeState(): void;
    updateState({ props, changeFlags }: {
        props: any;
        changeFlags: any;
    }): void;
    renderLayers(): TileLayer<any, {
        id: string;
        getTileData: any;
        maxRequests: 20;
        pickable: true;
        onViewportLoad: any;
        autoHighlight: any;
        highlightColor: number[];
        minZoom: any;
        maxZoom: any;
        tileSize: 256;
        zoomOffset: 0 | -1;
        renderSubLayers: any;
        tileSource: any;
        showTileBorders: any;
    }>[];
}
//# sourceMappingURL=tile-source-layer.d.ts.map